<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="MetaModules|SSH Key Testing">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>SSH Key Testing MetaModule</title>
        
        <link href="../../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../../index.html#18-metamodules/ssh-key-testing/ssh-key-testing.html">Open topic with navigation</a>
        </p>
        <h1>SSH Key Testing MetaModule</h1>
        <p>SSH public key authentication provides a secure method of logging in to a remote host. It uses an SSH key pair to authenticate a login instead of the traditional user name and password combination. The SSH key pair consists of a private and public SSH key. The private SSH key is stored on the local machine and enables you to log in to remote systems on which the corresponding public key is installed. </p>
        <p> 

If you obtain an unencrypted SSH private key from a compromised target machine, you can run the SSH Key Testing MetaModule. This MetaModule enables you to bruteforce logins on a range of hosts to identify remote machines that can be authenticated with the private key. During the MetaModule run, <span class="VariablesProductName">Metasploit Pro</span> displays real-time statistics for the number of hosts targeted, the number of login attempts made, and the number of successful logins. After the MetaModule completes its run, it generates a complete report that provides the details for the hosts it was able to successfully authenticate. </p>
        <h2>Running the SSH Key&#160;Testing MetaModule</h2>
        <p>Before you can run the SSH Key Testing MetaModule, you must either have a SSH private key available that you can upload to your project or your project must contain a looted SSH private key obtained from a scan, a bruteforce attack, or some other exploit method.</p>
        <ol>
            <li value="1">From within a project, select <b class="UISelection">Modules &gt; MetaModules</b>.<br /><br /><img src="../../Resources/Images/ssh-apps-tab-1_386x50.png" style="width: 386;height: 50;" /></li>
            <li value="2">Find the <b class="UISelection">SSH Key Testing</b> MetaModule and click the <b class="UISelection">Launch</b> button. The SSH Key Testing window appears.<br /><br /><img src="../../Resources/Images/ssh-metamodule-1_372x216.png" style="width: 372;height: 216;" /></li>
            <li value="3">From the <b class="UISelection">Scope</b> tab, enter the target address range you want to use for the test.<br /><br /><img src="../../Resources/Images/ssh-scope-1_330x191.png" style="width: 330;height: 191;" /></li>
            <li value="4">Click on the <b class="UISelection">Credentials</b> tab. The Credentials form appears. </li>
            <li value="5">Choose one of the following options to supply the MetaModule with an SSH private key:</li>
        </ol>
        <ul start="6">
            <li class="indentedList" value="6"><b class="UISelection">Enter a known credential pair</b>- You need to manually enter the user name, and then browse to the location of the private key that you want the MetaModule to use.</li>
            <li class="indentedList" value="7"><b class="UISelection">Choose an existing SSH key</b> - You can select a user name and SSH key from a list of looted keys. These keys were obtained from a bruteforce attack, discovery scan, data import, or exploited system.<br /><br /><img src="../../Resources/Images/ssh-creds-1_314x233.png" style="width: 314;height: 233;" /></li>
        </ul>
        <ol start="6">
            <li value="6">Click the <b class="UISelection">Report </b>tab. The Report configuration form appears.</li>
            <li value="7">Enter a name for the report in the <b class="UISelection">Report Name</b> field, if you want to use a custom report name.  Otherwise, the MetaModule uses the default report name.<br /><br /><img src="../../Resources/Images/single-pswd-report-1_330x238.png" style="width: 330;height: 238;" /></li>
            <li value="8">Choose whether you want to generate the report as a PDF, HTML, or RTF file. <br /></li>
            <li value="9">From the <b class="UISelection">Sections </b>area, deselect any sections you do not want to include in the report. Skip this step if you want to generate all the report sections.<br /><br /><img src="../../Resources/Images/single-pswd-report-sections-1_205x95.png" style="width: 205;height: 95;" /></li>
            <li value="10">Select the <b class="UISelection">Email Report</b> option if you want to e-mail the report after it generates. If you enable this option, you need to supply a comma separated list of e-mail addresses.</li>
        </ol>
        <p class="NoteList" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>If you want to e-mail a report, you must set up a local mail server or e-mail relay service for <span class="VariablesProductName">Metasploit Pro</span> to use. To define your mail server settings, select <b class="UISelection">Administration &gt; Global Settings &gt; SMTP Settings</b>.</p>
        <ol start="11">
            <li value="11">Click the <b class="UISelection">Launch</b> button.</li>
        </ol>
        <p>When the MetaModule launches, the Findings window appears and displays the real-time statistics and tasks log for the MetaModule run. You can track the total number of hosts that the MetaModule attempted to authenticate, the total number of login attempts, and the total number of successful logins. If you want to view all the event details, you can click on the Task Log tab.</p>
        <p>
            <img src="../../Resources/Images/ssh-findings-1_385x176.png" style="width: 385;height: 176;" />
        </p>
        <p>After the MetaModule completes its run, you should go the Reports area to view the SSH Key Testing Report. The first few pages of the report show graphs and tables that provide a high-level breakdown of cracked hosts and services.  For a more detailed look at the hosts, you can look at the Authenticated Services and Hosts Details section, which shows the services that were authenticated and the sessions that were opened on each host.</p>
    </body>
</html>